]> git.ipfire.org Git - thirdparty/git.git/blame - git-sh-setup.sh
cherry-pick, revert: add the --gpg-sign option
[thirdparty/git.git] / git-sh-setup.sh
CommitLineData
11d62145
JN
1# This shell scriplet is meant to be included by other shell scripts
2# to set up some variables pointing at the normal git directories and
3# a few helper shell functions.
b33e9666 4
365527ad 5# Having this variable in your environment would break scripts because
e598c517 6# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
7# like CDPATH, define it for your interactive shell sessions without
8# exporting it.
785063e0 9# But we protect ourselves from such a user mistake nevertheless.
365527ad
JH
10unset CDPATH
11
393050c3
JH
12# Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
13# do not equate an unset IFS with IFS with the default, so here is
14# an explicit SP HT LF.
15IFS='
16'
785063e0 17
61dbb3c4
JH
18git_broken_path_fix () {
19 case ":$PATH:" in
20 *:$1:*) : ok ;;
21 *)
22 PATH=$(
23 SANE_TOOL_PATH="$1"
24 IFS=: path= sep=
25 set x $PATH
26 shift
27 for elem
28 do
29 case "$SANE_TOOL_PATH:$elem" in
30 (?*:/bin | ?*:/usr/bin)
31 path="$path$sep$SANE_TOOL_PATH"
32 sep=:
33 SANE_TOOL_PATH=
34 esac
35 path="$path$sep$elem"
36 sep=:
37 done
38 echo "$path"
39 )
40 ;;
41 esac
42}
43
44# @@BROKEN_PATH_FIX@@
0e0aea5a 45
adb231cf
FG
46die () {
47 die_with_status 1 "$@"
48}
49
50die_with_status () {
51 status=$1
52 shift
89b0230a 53 printf >&2 '%s\n' "$*"
adb231cf 54 exit "$status"
b33e9666
LT
55}
56
e064c170
SB
57GIT_QUIET=
58
59say () {
60 if test -z "$GIT_QUIET"
61 then
62 printf '%s\n' "$*"
63 fi
64}
65
bac199b7
PH
66if test -n "$OPTIONS_SPEC"; then
67 usage() {
5d292756
JH
68 "$0" -h
69 exit 1
bac199b7
PH
70 }
71
e817e3e8
PH
72 parseopt_extra=
73 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
74 parseopt_extra="--keep-dashdash"
75
76 eval "$(
cbea86fd 77 echo "$OPTIONS_SPEC" |
e817e3e8
PH
78 git rev-parse --parseopt $parseopt_extra -- "$@" ||
79 echo exit $?
80 )"
bac199b7 81else
1b1dd23f 82 dashless=$(basename "$0" | sed -e 's/-/ /')
bac199b7 83 usage() {
0b54366c 84 die "usage: $dashless $USAGE"
bac199b7
PH
85 }
86
87 if [ -z "$LONG_USAGE" ]
88 then
0b54366c 89 LONG_USAGE="usage: $dashless $USAGE"
bac199b7 90 else
0b54366c 91 LONG_USAGE="usage: $dashless $USAGE
bac199b7
PH
92
93$LONG_USAGE"
94 fi
95
96 case "$1" in
87182b17 97 -h)
bac199b7
PH
98 echo "$LONG_USAGE"
99 exit
100 esac
101fi
d025524d 102
c3e2d189
JH
103# Set the name of the end-user facing command in the reflog when the
104# script may update refs. When GIT_REFLOG_ACTION is already set, this
105# will not overwrite it, so that a scripted Porcelain (e.g. "git
106# rebase") can set it to its own name (e.g. "rebase") and then call
107# another scripted Porcelain (e.g. "git am") and a call to this
108# function in the latter will keep the name of the end-user facing
109# program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
110# does will be record as actions done as part of the end-user facing
111# operation (e.g. "rebase").
112#
113# NOTE NOTE NOTE: consequently, after assigning a specific message to
114# GIT_REFLOG_ACTION when calling a "git" command to record a custom
115# reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
116# after you are done. Other callers of "git" commands that rely on
117# writing the default "program name" in reflog expect the variable to
118# contain the value set by this function.
119#
120# To use a custom reflog message, do either one of these three:
121#
122# (a) use a single-shot export form:
123# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
124# git command-that-updates-a-ref
125#
126# (b) save the original away and restore:
127# SAVED_ACTION=$GIT_REFLOG_ACTION
128# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
129# git command-that-updates-a-ref
130# GIT_REFLOG_ACITON=$SAVED_ACTION
131#
132# (c) assign the variable in a subshell:
133# (
134# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
135# git command-that-updates-a-ref
136# )
f9474132
SP
137set_reflog_action() {
138 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
139 then
140 GIT_REFLOG_ACTION="$*"
141 export GIT_REFLOG_ACTION
142 fi
143}
144
ef0c2abf 145git_editor() {
b4479f07
JN
146 if test -z "${GIT_EDITOR:+set}"
147 then
148 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
149 fi
150
151 eval "$GIT_EDITOR" '"$@"'
ef0c2abf
AR
152}
153
f6dff119
JN
154git_pager() {
155 if test -t 1
156 then
157 GIT_PAGER=$(git var GIT_PAGER)
158 else
159 GIT_PAGER=cat
160 fi
161 : ${LESS=-FRSX}
e54c1f2d
JN
162 : ${LV=-c}
163 export LESS LV
f6dff119
JN
164
165 eval "$GIT_PAGER" '"$@"'
166}
167
e1622bfc
JH
168sane_grep () {
169 GREP_OPTIONS= LC_ALL=C grep "$@"
170}
171
172sane_egrep () {
173 GREP_OPTIONS= LC_ALL=C egrep "$@"
174}
175
4b441f47 176is_bare_repository () {
5be60078 177 git rev-parse --is-bare-repository
4b441f47
JH
178}
179
9fde9401 180cd_to_toplevel () {
91dc602d
SD
181 cdup=$(git rev-parse --show-toplevel) &&
182 cd "$cdup" || {
183 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
184 exit 1
185 }
9fde9401
JH
186}
187
e2eb5273
JH
188require_work_tree_exists () {
189 if test "z$(git rev-parse --is-bare-repository)" != zfalse
190 then
191 die "fatal: $0 cannot be used without a working tree."
192 fi
193}
194
7eff28a9 195require_work_tree () {
ab62677b 196 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
7eff28a9
SP
197 die "fatal: $0 cannot be used without a working tree."
198}
199
92c62a3f
RR
200require_clean_work_tree () {
201 git rev-parse --verify HEAD >/dev/null || exit 1
202 git update-index -q --ignore-submodules --refresh
203 err=0
204
205 if ! git diff-files --quiet --ignore-submodules
206 then
207 echo >&2 "Cannot $1: You have unstaged changes."
208 err=1
209 fi
210
211 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
212 then
213 if [ $err = 0 ]
214 then
215 echo >&2 "Cannot $1: Your index contains uncommitted changes."
216 else
217 echo >&2 "Additionally, your index contains uncommitted changes."
218 fi
219 err=1
220 fi
221
222 if [ $err = 1 ]
223 then
224 test -n "$2" && echo >&2 "$2"
225 exit 1
226 fi
227}
228
ce80ca56
JK
229# Generate a sed script to parse identities from a commit.
230#
231# Reads the commit from stdin, which should be in raw format (e.g., from
232# cat-file or "--pretty=raw").
233#
234# The first argument specifies the ident line to parse (e.g., "author"), and
235# the second specifies the environment variable to put it in (e.g., "AUTHOR"
236# for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
237# committer.
238pick_ident_script () {
239 while test $# -gt 0
240 do
241 lid=$1; shift
242 uid=$1; shift
243 printf '%s' "
244 /^$lid /{
245 s/'/'\\\\''/g
246 h
247 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
248 s/.*/GIT_${uid}_NAME='&'/p
249
250 g
251 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
252 s/.*/GIT_${uid}_EMAIL='&'/p
253
254 g
255 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
256 s/.*/GIT_${uid}_DATE='&'/p
257 }
258 "
259 done
260 echo '/^$/q'
261}
262
263# Create a pick-script as above and feed it to sed. Stdout is suitable for
264# feeding to eval.
265parse_ident_from_commit () {
266 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
267}
268
269# Parse the author from a commit given as an argument. Stdout is suitable for
270# feeding to eval to set the usual GIT_* ident variables.
0cae2346 271get_author_ident_from_commit () {
0cae2346 272 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 273 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
ce80ca56 274 parse_ident_from_commit author AUTHOR
0cae2346
JS
275}
276
7d750f0e
GB
277# Clear repo-local GIT_* environment variables. Useful when switching to
278# another repository (e.g. when entering a submodule). See also the env
279# list in git_connect()
280clear_local_git_env() {
281 unset $(git rev-parse --local-env-vars)
282}
283
4549162e
KB
284# Generate a virtual base file for a two-file merge. Uses git apply to
285# remove lines from $1 that are not in $2, leaving only common lines.
286create_virtual_base() {
287 sz0=$(wc -c <"$1")
288 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
289 sz1=$(wc -c <"$1")
290
291 # If we do not have enough common material, it is not
292 # worth trying two-file merge using common subsections.
293 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
294}
295
87bddba9 296
10587ce6 297# Platform specific tweaks to work around some commands
87bddba9
JS
298case $(uname -s) in
299*MINGW*)
300 # Windows has its own (incompatible) sort and find
301 sort () {
302 /usr/bin/sort "$@"
303 }
304 find () {
305 /usr/bin/find "$@"
306 }
be39048a
RJ
307 # git sees Windows-style pwd
308 pwd () {
309 builtin pwd -W
310 }
5e9677cb
PT
311 is_absolute_path () {
312 case "$1" in
313 [/\\]* | [A-Za-z]:*)
314 return 0 ;;
315 esac
316 return 1
317 }
87bddba9 318 ;;
5e9677cb
PT
319*)
320 is_absolute_path () {
321 case "$1" in
322 /*)
323 return 0 ;;
324 esac
325 return 1
326 }
87bddba9 327esac
10587ce6
JH
328
329# Make sure we are in a valid repository of a vintage we understand,
330# if we require to be in a git repository.
331if test -z "$NONGIT_OK"
332then
333 GIT_DIR=$(git rev-parse --git-dir) || exit
334 if [ -z "$SUBDIRECTORY_OK" ]
335 then
336 test -z "$(git rev-parse --show-cdup)" || {
337 exit=$?
338 echo >&2 "You need to run this command from the toplevel of the working tree."
339 exit $exit
340 }
341 fi
342 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
343 echo >&2 "Unable to determine absolute path of git directory"
344 exit 1
345 }
346 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
347fi
bac1ddd0
RR
348
349peel_committish () {
350 case "$1" in
351 :/*)
352 peeltmp=$(git rev-parse --verify "$1") &&
353 git rev-parse --verify "${peeltmp}^0"
354 ;;
355 *)
356 git rev-parse --verify "${1}^0"
357 ;;
358 esac
359}